# Snort 3 IPv6 NDP Detection Plugin #

This is a Plugin for Snort++ (3) that detects typical Ipv6 NDP Attacks.
It was developed as part of my bachelor thesis.

## Installation ##

Install Snort++, last tested verion was 241 from git.

1. clone Project
2. change into Project directory
3. cmake .
4. make install

## Configuration ##

This is a simple example configuration for the inspection Plugin.

`indp = {
        use_ipv6 = false,
        flood_window = 3,
        flood_count = 10,
        routers = { mac = "00:15:17:bf:48:31", mac2 = "00:A5:17:bf:48:31"}, 
        prefixes = { prefix = "2201:adb:12d::0", bitmask=48, prefix2 = "2001:adb:12d::0", bitmask2=56}  
}`

For full configuration please see `snort --help-module indp `
You have to setup Plugin Path before that.

## Rules ##

We include the following ips option:
* ips_ipv
* ips_ip6_exthdr
* ips_ip6_flow
* ips_ip6_padn
* ips_ip6_rh

The help-module command shows how to user these options in rules.