/**
    CS-11 Asn 2
    topList.cc
    Purpose: Topology List for indp

    @author Max Schroetter
    @version 0.1 13.12.17
    Fix-Later Comments to be fixed
*/

#include "ndpCache.h"
#include "protocols/ip.h"
#include <vector>

struct host_key {
    uint64_t uip6addr;
    uint64_t lip6addr;
    uint64_t mac_addr;

    bool operator==(const host_key &other) const {
        return (uip6addr == other.uip6addr && lip6addr == other.lip6addr && mac_addr == other.mac_addr);
    }
};

struct host_key_hasher
{
  std::size_t operator()(const host_key& k) const
  {
    using std::size_t;
    using std::hash;
    using std::string;

    return ((hash<uint64_t>()(k.uip6addr)
             ^ (hash<uint64_t>()(k.lip6addr) << 1)) >> 1)
             ^ (hash<uint64_t>()(k.mac_addr) << 1);
  }
};

struct router_entry
{
    uint8_t mac_addr[6];
    ip::snort_in6_addr dst_addr;
    ip::snort_in6_addr src_addr;
    uint8_t flags;
    uint8_t prefix_flags;
    ip::snort_in6_addr prefix;
};
struct host_entry
{
    uint8_t mac_addr[6];
    ip::snort_in6_addr ip6_addr;
    int advertise_count;
};

typedef NdpCache<host_key,host_entry,host_key_hasher> HostCache;
typedef NdpCache<uint64_t,router_entry,std::hash<unsigned long long>> RouterCache;

int main()
{
    HostCache* hosttest = new HostCache(1000);
    RouterCache* routertest = new RouterCache(1000);
}
