#include "protocols/packet.h"
#include "protocols/ipv6.h"

struct ICMP6NeighborSolicitation
{
	uint8_t type;
	uint8_t code;
	uint16_t csum;
	uint32_t reserved;
	ip::snort_in6_addr trg_addr;
};

struct ICMP6NeighborAdvertisement
{
	uint8_t type;
	uint8_t code;
	uint16_t csum;
	uint8_t rso;
	uint8_t reserved1;
	uint16_t reserved2;
	ip::snort_in6_addr trg_addr;
};
struct ICMP6RouterSolicitation
{
	uint8_t type;
	uint8_t code;
	uint16_t csum;
	uint32_t reserved;
	ip::snort_in6_addr trg_addr;

};
struct ICMP6RouterAdvertisement
{
	uint8_t type;
	uint8_t code;
	uint16_t csum;
	uint8_t hop_limit;
	uint8_t m0;
	uint16_t router_lifetime;
	uint32_t reachable_time;
	uint32_t retrans_timer;

};
struct ICMP6RedirectMessage
{
	uint8_t type;
	uint8_t code;
	uint16_t csum;
	uint32_t reserved;
	ip::snort_in6_addr trg_addr;
	ip::snort_in6_addr dst_addr;
};
struct ICMP6PrefixOpt
{
	uint8_t type;
	uint8_t len;
	uint8_t prefix_len;
	uint8_t flags;
	uint32_t valid_life;
	uint32_t pref_life;
	uint32_t reserved;
	ip::snort_in6_addr prefix;
};
struct ICMP6TrgOpt
{
	uint8_t type;
	uint8_t len;
	uint8_t addr[6];
};
